/****************************************************************************
	Bagotronix
	1019 Crossing Brook Way
	Tallahassee, FL 32311

	(C) Copyright 1998 Bagotronix
	All rights reserved

	Filename:  		chktilt.c
	Programmer(s):	Ivan Baggett
	Description:	Chickadee(tm) example application for inclination sensing.
	comments:		Uses Lucas Sensing Systems Accustar II
					dual axis clinometer (tilt sensor).
					Chickadee ADC is set up for absolute 0 - 4.095 V range.
****************************************************************************/

#include <dos.h>
#include <stdio.h>

#include "stdinc.h"
#include "chickade.h"
#include "csfcadc.h"

#define _getch getch		// for Borland console

// scale factor for operating Accustar II on +5V supply (mV per degree)
#define TILT_SCALE 56
#define TILT_OFFSET 0x9c4

int main (void) {

	BOOLEAN done = FALSE;
	int c, i;
	UWORD u;
	UBYTE b;

	printf ("Strike the 'X' key to quit, any other alphanumeric key to sample.\n\n");

	while (!done) {
		while (!kbhit());
		c = _getch();
		if (c == 'x' || c == 'X')
			done = TRUE;

		printf ("\n");
		// X axis is on ADC channel 0
		// Y axis is on ADC channel 2
		for (i = 0; i <= 2; i += 2) {
			u = ADCget (MAX186, (UBYTE)i, 0);	/* MAX186, channel i, 0 acq delay */
			/* 12-bit ADC result is normalized to MSB, so denormalize it (/16) */
			u /= 16;

			c = ((((int)u * 2 - TILT_OFFSET * 2) + 1) / 2) / TILT_SCALE;
			printf ("%c axis: %d\n", 'X' + i / 2, c);	/* to remote console */
		}
	}

	return 0;
}
